package org.gcube.portlets.user.geoportaldataviewer.client;

import java.util.List;

import org.gcube.portlets.user.geoportaldataviewer.shared.GeoNaDataViewerProfile;
import org.gcube.portlets.user.geoportaldataviewer.shared.GeoNaItemRef;
import org.gcube.portlets.user.geoportaldataviewer.shared.GeoNaSpatialQueryResult;
import org.gcube.portlets.user.geoportaldataviewer.shared.gis.BoundsMap;
import org.gcube.portlets.user.geoportaldataviewer.shared.gis.LayerObject;
import org.gcube.portlets.user.geoportaldataviewer.shared.gis.wms.GeoInformationForWMSRequest;
import org.gcube.portlets.user.geoportaldataviewer.shared.products.ConcessioneDV;
import org.gcube.portlets.user.geoportaldataviewer.shared.products.model.UploadedImageDV;

import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.rpc.AsyncCallback;

public interface GeoportalDataViewerServiceAsync {
	/**
	 * Utility class to get the RPC Async interface from client-side code
	 */
	public static final class Util {
		private static GeoportalDataViewerServiceAsync instance;

		public static final GeoportalDataViewerServiceAsync getInstance() {
			if (instance == null) {
				instance = (GeoportalDataViewerServiceAsync) GWT.create(GeoportalDataViewerService.class);
			}
			return instance;
		}

		private Util() {
			// Utility class should not be instantiated
		}
	}

	void parseWmsRequest(String wmsRequest, String layerName, AsyncCallback<GeoInformationForWMSRequest> callback);

	void getDataResult(List<LayerObject> layerObjects, String mapSrsName, BoundsMap mapBBOX, int maxWFSFeature, double zoomLevel,
			AsyncCallback<List<GeoNaSpatialQueryResult>> callback);

	void getConcessioneForId(Long id, AsyncCallback<ConcessioneDV> callback);

	void getMyLogin(AsyncCallback<String> callback);

	void getLayerForType(String layerType, AsyncCallback<GeoInformationForWMSRequest> callback);

	void getGeoNaDataViewProfile(AsyncCallback<GeoNaDataViewerProfile> callback);

	void getUploadedImagesForId(String itemType, Long id, int maxImages, AsyncCallback<List<UploadedImageDV>> callback);

	void getPublicLinksFor(GeoNaItemRef item, AsyncCallback<GeoNaItemRef> asyncCallback);

	void getShortUrl(String longUrl, AsyncCallback<String> callback);
}
